<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';

//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id'])  or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

function getPrintSettings($conn_rjllearning_specific, $institution_id,  $search_string, $limit, $offset)
{
 
    $sql_count = "SELECT COUNT(*) AS total_rows FROM print_settings WHERE institution_id = ? ";
    $array_params = [$institution_id];
    $stmt = $conn_rjllearning_specific->prepare($sql_count);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];
    if ($limit == 'all') {
        $sql = "SELECT * FROM  print_settings  where institution_id =? " ;
         $array_params = [$institution_id];
        if ($search_string != null) {
            $sql .= " AND (primary_color LIKE ? OR secondary_color LIKE ?)  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
    
    } else {
        $sql = "SELECT * FROM print_settings WHERE institution_id = ? ";
        $array_params = [$institution_id];
         if ($search_string != null) {
            $sql .= " AND (primary_color LIKE ? OR secondary_color LIKE ?)  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
        
        $sql .= " LIMIT " . $offset . " ," . $limit . " ";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_class = $stmt->fetchAll();
    $array_return = [];
    $branches = [];
    if(count($result_class) >= 1){
       
    foreach ($result_class as $rows) {

        $array_return[] =  array('setting_id' => $rows['id'],'institution_id' => $rows['institution_id'],'primary_color' => $rows['primary_color']
        ,'secondary_color' => $rows['secondary_color'],'id_card_template_selected' => $rows['id_card_template_selected']);
    }
    }
    if (count($result_class) < 50) {

        return array('total_rows' => $totalrows, 'print_settings' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'print_settings' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type']  == "print_settings") {

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $limit = $postdata['limit'];
  
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getPrintSettings($conn_rjllearning_specific, $institution_id, $search_string, $limit, $offset);
        successreturn($success);
    } else {

        $success['data'] = getPrintSettings($conn_rjllearning_specific, $institution_id, $search_string, $limit, null);
        successreturn($success);
    }
}
